<template>
  <section >
    <div class="title">Edit Blogs</div>
    <form action="" method="submit">
    <section>
        <b-field label="Tiêu Đề">
          <b-input placeholder="Tiêu Đề" v-model="title"></b-input>
        </b-field>
        <b-field label="Mô Tả Ngắn">
          <b-input placeholder="Mô tả ngắn" v-model="des"></b-input>
        </b-field>
        <b-field label="Chi Tiết">
          <b-input type="textarea" maxlength="1000" v-model="detail"></b-input>
        </b-field>
        <b-field label="Hình Ảnh">
          <b-input v-model="thumbs" type="file"></b-input>
        </b-field>
         <b-field label="Loại">
            <b-select v-model="category">
              <option v-for="(item,key) in dataCategory" :key="key">{{item.namecategory}}</option>
            </b-select>
          </b-field>
          <div>
            <div >
              <div class="columns">
              <p  class="public" >Vị Trí</p>
            </div>
            <div v-for="(item,key) in dataPosition" :key="key">
                <b-checkbox v-model="checkboxGroup"
                :native-value="item.position">
               {{item.position}}
            </b-checkbox>
            <!-- <label for="checkbox">{{checkboxGroup}}</label> -->
            </div>
            </div>
          </div>
          <div class="columns">
            <p class="public" >Public</p>
          </div>
          <div class="columns radio">
            <b-radio v-model="radio" native-value="true" >Yes</b-radio>
          </div>
          <div class="columns radio">
            <b-radio v-model="radio" native-value="false" >No</b-radio>
          </div>
          <b-field label="Date Pubblic">
            <b-input v-model="datePubblic" type="date"></b-input>
          </b-field>
        </section>
      <b-button type="submit is-success" class="btn-submit" @click="submit(id)">Submit</b-button>
      <b-button type="is-danger" class="btn-submit" @click="clearForm">Clear</b-button>
    </form>
  </section>
</template>

<script>
import callApi from './../middleware/apiCaller.js'
export default {
  data(){
    return{
      des:'',
      detail:'',
      items:[],
      title:'',
      category:'',
      checkboxGroup:[],
      dataPosition:'',
      dataCategory:'',
      radio:'',
      datePubblic:'',
      id:'',
      thumbs:''
    }
  },
  mounted(){
    this.id=localStorage.id
      callApi('position', 'GET',null).then(res =>{
      this.dataPosition=res.data
    })
    callApi('category','GET',null).then(res =>{
      this.dataCategory=res.data
    })
    callApi('blogs', 'GET', null).then(res =>{
      this.items=res.data
      for(let i = 0; i < this.items.length; i++){
        if(this.items[i].id==localStorage.id){
         return(
           this.title=this.items[i].title,
          this.des=this.items[i].des,
          this.detail=this.items[i].detail,
          this.category=this.getCategory(this.items[i].category),
          this.getPosition(this.items[i].position),
          this.radio=this.items[i].public,
          this.datePubblic=this.items[i].data_pubblic
         ) 
        }
      }
    })
  
    
  },
  updated(){

  },
  methods:{
    submit(key){
       if( this.title!=='' && this.des!=='' && this.detail!=='' &&  this.category!=='' && this.checkboxGroup!=='' && this.radio!=='' && this.datePubblic!=='' ){
        this.$dialog.confirm({
        title: 'Edit',
        message: 'Are you sure you want to <b>Edit</b> your Instance? This action cannot be undone.',
        confirmText: 'Edit Intance',
        type: 'is-danger',
        hasIcon: true,
        onConfirm: () => {
         
            // var today= new Date()
          callApi('blogs/'+key,'PUT',{
            id:'',
            title:this.title,
            des:this.des,
            detail:this.detail,
            category:this.postCategory(this.category),
            position:this.postPosition(this.checkboxGroup),
            public:this.radio,
            thumbs:this.thumbs,
            // updated: today,
            data_pubblic:this.datePubblic,
          })
          this.$toast.open('Edit Completed!')
        
        }
      })
      }else{
            this.$dialog.alert({
                    title: 'Error',
                    message: 'Please do not leave any fields blank',
                    type: 'is-danger',
                    hasIcon: true,
                    icon: 'times-circle',
                    iconPack: 'fa'
                })
          }
    },

    clearForm(){
      this.title='',
      this.des='',
      this.detail='',
      this.category='',
      this.checkboxGroup='',
      this.radio='',
      this.datePubblic=''
    },

    getCategory(id){
      for( let i=0 ; i < this.dataCategory.length; i++){
        if(this.dataCategory[i].id===id){
          return this.dataCategory[i].namecategory
        }
      }
    },
    postCategory(id){
      for( let i=0 ; i < this.dataCategory.length; i++){
        if(this.dataCategory[i].namecategory===id){
          return this.dataCategory[i].id
        }
      }
    },
    getPosition(position){
      for(let i = 0 ; i < position.length; i++){
        for(let j = 0; j < this.dataPosition.length; j++){
          if(this.dataPosition[j].id===position[i]){
            return this.checkboxGroup[i]=this.dataPosition[j].position
          }
        }
      }
    },
    postPosition(position){
      for(let i = 0 ; i < position.length; i++){
        for(let j = 0; j < this.dataPosition.length; j++){
          if(this.dataPosition[j].position===position[i]){
            return [this.dataPosition[j].id]
          }
        }
      }
    },
  },
  watch:{
    title(newTitle){
      this.title=newTitle
    },
    des(newDes){
      this.des=newDes
    },
    detail(newDetail){
      this.detail=newDetail
    }
  }
}
</script>

<style scoped>
.section{
  width: 80%;
}
.radio{
  margin: 0px 0px;
  margin-bottom: 7px;
}
.public{
  font-weight: 500;
  margin-left: 10px;
  margin-top: 10px
}
.checkbox{
  margin: 10px 10px;
}
.btn-submit{
  height: 50px;
  width: 200px;
  margin-top: 2%;
  margin-left: 15%
}
</style>
